
/*****************************************************************************/
/*                                                                           */
/*  Practica de Sistemes Informatics en Temps Real                           */
/*                                                                           */
/*  Implementacio d'un sequenciador de MIDI per mitja de Real Time Linux     */
/*  enviar_freq.c: fitxer que implementa la lectura del fitxer de            */
/*                 frequencies MIDI i l'enviament inicial cap a RT-Linux.    */
/*                                                                           */
/*  Realitzat per: Francisco Jose Aguilar Celdran i Sergio Blanco Cuaresma   */ 
/*                                                                           */
/*****************************************************************************/


#include <stdio.h>
#include <errno.h>
#include <sys/time.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/ioctl.h>
#include <rtl_compat.h>
#include <rtl_fifo.h>
#include "control.h"

char buf[TAM_BUFFER];

int main(int argc, char **argv)
{
   int fifo_frequencies;
   int fifo_entrada;
   int i;
   struct taula_musical taula_midi;
   float freq;
   FILE *fitxer_midi;
   char resposta[11];

   i = 0;   
   // Lectura del fitxer de frequencies midi
   fitxer_midi = fopen("pitch-freq.txt","r");
   fscanf(fitxer_midi,"%f",&freq);
   while (!feof(fitxer_midi)) {
      taula_midi.freq[i] = freq;
      // Conversio de frequencies a tics: meitat del periode en segs * RT_TICKS_PER_SEC
      taula_midi.tics_flanc[i] = (1 / (2 * taula_midi.freq[i])) * RT_TICKS_PER_SEC;
      fscanf(fitxer_midi,"%f",&freq);
      i++;
   }
   fclose(fitxer_midi);
   
   // Obrim les RT-FIFOs
   if ((fifo_frequencies = open("/dev/rtf1", O_WRONLY)) < 0) {
      fprintf(stderr, "Error opening /dev/rtf1\n");
      exit(1);
   }
   if ((fifo_entrada = open("/dev/rtf3", O_RDONLY)) < 0) {
      fprintf(stderr, "Error opening /dev/rtf3\n");
      exit(1);
   }

   // Enviem les frequencies midi entre 50 i 100
   if (write(fifo_frequencies,&taula_midi,sizeof(struct taula_musical)) < 0) {
      fprintf(stderr, "Error en enviar les frequencies midi a la RT-Tasca\n");
      exit(1);
   }

   read(fifo_entrada,resposta,9);  // Per comprovar que ha rebut RT-Linux
   close(fifo_entrada);
   close(fifo_frequencies);
   return 0;
}


